/****************************************************************************
 * NCSA HDF                                                                 *
 * Software Development Group                                               *
 * National Center for Supercomputing Applications                          *
 * University of Illinois at Urbana-Champaign                               *
 * 605 E. Springfield, Champaign IL 61820                                   *
 *                                                                          *
 * For conditions of distribution and use, see the accompanying             *
 * COPYING file.                                                            *
 *                                                                          *
 ****************************************************************************/

#ifndef HTML_UTIL_H
#define HTML_UTIL_H

#include "glist.h"
#include <stdio.h>

#define MAXHDRCOLS 50

/* table list elements */
typedef struct tbl_t {
    char      *hdr;     /* table hdr itself */
} tbl_st, *tbl_stp;

/* table data  elements */
typedef struct tbldata_t {
    void      *data;     /* data to be operated on by function fn */
    void      (*fn)(void *pointer, void *args); /* function fn that does */
                                                /* the work on data */
} tbldata_st, *tbldata_stp;

#ifndef findMaxMin
/* finding max & min values from datasets */
#define findMaxMin(x, dataMax, dataMin) { \
    tmp=(x);  if(tmp > dataMax) dataMax=tmp; \
    if (tmp<dataMin) dataMin=tmp;}

#endif
#include <varargs.h>
/*------------------------- Prototypes -------------------------*/
IMPORT void InfoMsg(char *str);
IMPORT void print_strings(FILE *output, char **str);
IMPORT void gateway_err(FILE *fout, char *msg, int fatal);
IMPORT void print_label(FILE *fout, char *msg);
IMPORT void prhtml_hyperlink(FILE *fout, char *msg);
IMPORT void prhtml_boldlabel(FILE *fout, char *msg);
IMPORT void prhtml_title(FILE *fout, char *title, int count, 
            char *label_for_one, char *label_for_many1, char *label_for_many2,
            char *optional_phrase);
IMPORT void prhtml_3str(FILE *fout, char *str1, char *str2, char *str3);
IMPORT void prhtml_H2label(FILE *fout, char *msg);
IMPORT void prhtml_submitbutton(FILE *fout, char *title, char *submitmsg,
            char *resetmsg, int tag, int ref, int subnum, char *name,
            int display_mode);
IMPORT void prhtml_select_outputtype(FILE *fout, char *title, char *button_array[], int numbuttons);  
IMPORT int add_tblhdr_str(Generic_list *tbl_list, char *hdr);
IMPORT void prhtml_hdrentry(void *dptr, void *args);
IMPORT void 
prhtml_tblhdr(FILE *fout, char *caption, char *hdrarray[], int numofhdrs);
IMPORT void prhtml_wholetbl(FILE *fout, Generic_list list,
            void (*fn)(void *pointer, void *args));
IMPORT void prhtml_tblentry(FILE *fout, void *miscarg, void *arglist,
       void (*fn)(void *pointer, void *args));
IMPORT void prhtml_tblselectentry(FILE *fout, void *miscarg,
       void *arglist, void (*fn)(void *pointer, void *args));
IMPORT void
prhtml_form(FILE *fout, char *formtitle, char *scriptname, char *pathinfo, 
            char *selectlabel, int size, char *buttonlabel, char *browsebutton,
            char *browsefilename, int display_mode, Generic_list list,  
            void (*fn)(Generic_list list, FILE *fout, int numinlist, 
            char *lbl ), int numoflistitems, char *itemlabel);
IMPORT void pr_tblstr(void *dptr, void *args);
IMPORT void pr_tblnum(void *dptr, void *args);

#endif /* HTML_UTIL_H */
